﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;

namespace AppNotificationServer
{
    [ServiceContract]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
    public class Notifications
    {
        private static Dictionary<string,List<Uri>> subscribers = new Dictionary<string,List<Uri>>();
        private static object obj = new object();

        [WebInvoke(UriTemplate = "register?uri={uri}&appId={appId}", ResponseFormat = WebMessageFormat.Xml, Method = "GET")]
        public void Register(string uri,string appId)
        {            
            Uri channelUri = new Uri(uri, UriKind.Absolute);
            Subscribe(channelUri,appId);
        }

        private void Subscribe(Uri channelUri,string appId )
        {
            lock (obj)
            {
                if (subscribers.ContainsKey(appId) == false)
                {
                    subscribers.Add(appId, new List<Uri>());
                }


                if (!subscribers[appId].Exists((u) => u == channelUri))
                {
                    subscribers[appId].Add(channelUri);
                }
            }
            //OnSubscribed(channelUri, true);
        }

        [WebInvoke(UriTemplate = "GetSubscribers?appId={appId}", ResponseFormat = WebMessageFormat.Json, Method = "GET")]
        public List<Uri> GetSubscribers(string AppId)
        {
            return subscribers[AppId];
        }
    }
}